
local SheepDairy = ...

SheepDairy:registerAssetId("models/sheepDairy.fbx/Prefab/sheepDairy/sheepDairyPart", "SHEEP_DAIRY_PREFAB")

-- Register the cheese dairy monument
SheepDairy:register({
	DataType = "MONUMENT",
	Id = "SHEEP_DAIRY_MONUMENT",
	Name = "SHEEP_DAIRY_MONUMENT_NAME",
	Description = "SHEEP_DAIRY_MONUMENT_DESC",
	BuildingType = "GENERAL",
	BuildingPartSetList = {
		{
			Name = "SHEEP_DAIRY_PARTSETLIST_NAME",
                	BuildingPartList = { 
                            "SHEEP_DAIRY_PART",
                            "SHEEP_DAIRY_CHEESE_SIGN_PART"
                        }
                }
        },
	RequiredPartList = {
		-- Necessarily a list of 'MONUMENT_REQUIRED_PART_PAIR', no need to specify the DataType of each element of the list
		{ Category = "CORE", Quantity = 1 }
	},
        IsEditable = true
})

SheepDairy:register({
		DataType = "BUILDING_FUNCTION_ASSIGNABLE",
                Id = "SHEEP_DAIRY_ASSIGNABLE_FUNCTION",
                AuthorizedFunctionList = "SHEEP_DAIRY_FUNCTION_LIST"
})

SheepDairy:register({
		DataType = "BUILDING_FUNCTION_LIST",
                Id = "SHEEP_DAIRY_FUNCTION_LIST",
                AssetFunctionList = {
                        "SHEEP_DAIRY_MILK_FUNCTION",
                        "SHEEP_DAIRY_CHEESE_FUNCTION"
                }
})

SheepDairy:register({
--Dclare que l'objet que l'on cre appartient  la class BUILDING_PART
	DataType = "BUILDING_PART",
--Cr l'objet
	Id = "SHEEP_DAIRY_PART",
	Name = "SHEEP_DAIRY_NAME",
	Description = "SHEEP_DAIRY_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
--on dclare d'aller chercher SHEEP_DAIRY_PREFAB pour construire l'object final ( c'est dans le Fbx )
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "SHEEP_DAIRY_PREFAB"
	},
--Ca c'est pour dclarer le visuel de construction si il y en a un !
	ConstructionVisual = "SHEEP_DAIRY_PREFAB",
--Les ressources ncessaires.
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = {
			{ Resource = "STONE", Quantity = 2 }
		}
	},
	AssetBuildingFunction = "SHEEP_DAIRY_ASSIGNABLE_FUNCTION"
})

SheepDairy:register({
		DataType = "BUILDING_FUNCTION_LIVESTOCK_FARM",
                Id = "SHEEP_DAIRY_MILK_FUNCTION",
                Name = "SHEEP_DAIRY_MILK_FUNCTION_NAME",
		WorkerCapacity = 3,
		RelatedJob = { 
			Job = "SHEPHERD",
			Behavior = "WORK_BEHAVIOR"
		},
		ResourceProduced = {
			{ Resource = "SHEEP_DAIRY_MILK", Quantity = 1 }
		},
                SpawningLivestock = "PREFAB_LIVESTOCK_SHEEP",
                SpawnLivestockButtonText = "SHEEP_DAIRY_MILK_SPAWN_TEXT",
                RemoveLivestockButtonText = "SHEEP_DAIRY_MILK_REMOVE_TEXT"
})

SheepDairy:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = "SHEEP_DAIRY_CHEESE_FUNCTION",
                Name = "SHEEP_DAIRY_CHEESE_FUNCTION_NAME",
		WorkerCapacity = 2,
                RelatedJob = { Job = "CHEESE_MAKER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "SHEEP_DAIRY_MILK", Quantity = 50 }
                },
                ResourceListNeeded = {
                	{ Resource = "SHEEP_DAIRY_MILK", Quantity = 5 }
                },
                ResourceProduced = {
			{ Resource = "CHEESE", Quantity = 1 }
                }
})

SheepDairy:registerPrefabComponent("models/sheepDairy.fbx/Prefab/sheepDairy/sheepDairyPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {5.4, 1}
})

-- Override building part components properties (generated by the building asset processor) to add building zones

SheepDairy:registerPrefabComponent("models/sheepDairy.fbx/Prefab/sheepDairy/sheepDairyPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZoneData = {
            DataType = "BUILDING_ZONE", 
            Polygon = polygon.createRectangle( { 5.4, 6 }, { 0, -2.75 } )
        }
})

SheepDairy:registerAssetId("models/sheepDairy.fbx/Prefab/sheepDairy/cheeseSignPart", "SHEEP_DAIRY_CHEESE_SIGN_PREFAB")

SheepDairy:register({
--Dclare que l'objet que l'on cre appartient  la class BUILDING_PART
	DataType = "BUILDING_PART",
--Cr l'objet
	Id = "SHEEP_DAIRY_CHEESE_SIGN_PART",
	Name = "SHEEP_DAIRY_CHEESE_SIGN_NAME",
	Description = "SHEEP_DAIRY_CHEESE_SIGN_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
--on dclare d'aller chercher SHEEP_DAIRY_CHEESE_SIGN_PREFAB pour construire l'object final ( c'est dans le Fbx )
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "SHEEP_DAIRY_CHEESE_SIGN_PREFAB"
	},
--Les ressources ncessaires.
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 1 }
		}
	}
})

SheepDairy:registerPrefabComponent("models/sheepDairy.fbx/Prefab/sheepDairy/cheeseSignPart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the facades)
	HasBuildingZone = true,
	BuildingZone = { 0, 0 }
})


